# SVN Project Checkout Steps

## Richieste

- voglio scaricare il progetto su <https://svn.armundia.com/svn/PRJarm_am/branches/ISPBEstero/ADV360-BES-JB8_B2024_2/arm_am-pom>
- scarica anche <https://svn.armundia.com/svn/PRJarm_am/branches/ISPBEstero/ADV360-BES-JB8_B2024_2/asset-gui>
- crea un readme con le richieste che ho fatto
- crea uno script powershell che fa il build ed il deploy di arm_am-pom su C:\Dev2012\BUILDERS\jboss-eap-8.0
- il pom è nel folder arm_am-pom
- java 17 è su C:\Dev2012\BUILDERS\java\jdk-17.0.9
- aggiorna il readme
- deve usare standalone-full-ADV360-BES-EAP_8_POSTGRES.xml
- voglio compilare e lanciare il progetto asset-gui
- jboss deve usare le opzioni "-DIDServer=GS -Dbtf.PathToParse=C:\Dev2012\advc0\in -Djava.awt.headless=true -DFilOptimize=true -DMTH_VALID_JB=internal -DskQueueElab=GS -DskQueueWrite=GS -DmtSession=GS"
- C:\Dev2012\BUILDERS\jboss-eap-8.0\bin\add-user.bat -u admin -p admin.123 -g SuperUser --silent
- dir $env:USERPROFILE\.m2\repository\com\armundia -Recurse | Where-Object { $_.Name -like "*.pom" }

## Projects Downloaded (Sync-Projects.ps1)

## Project Structure

### arm_am-pom

- Java/JEE project containing:
  - arm_am-ejb: EJB modules and web services
  - arm_am-jUnit: Test files
  - arm_am-web: Web application components

### asset-gui

- Web application frontend project containing:
  - Frontend source code in `source` directory
  - UI libraries (Font Awesome, Bootstrap, amCharts, Roboto fonts)
  - Build configuration files (gulpfile.js, package.json, babel.config.js)

## Build and Deployment Scripts

### Sync-Projects.ps1

PowerShell script to sync projects:

- Scarica usando svn i progetti arm_am-pom, asset-gui e tutti i moduli utilizzati.
- Esegue il build dei jar dei moduli utilizzati e li aggiunge al repository mvn locale

### start-jboss.ps1

PowerShell script to start JBoss EAP 8.0 server:

- Uses Java 17 from `C:\Dev2012\BUILDERS\java\jdk-17.0.9`
- Uses `standalone-full-ADV360-BES-EAP_8_POSTGRES.xml` configuration
- Sets required system properties
- Admin console available at <http://localhost:9990>
- JBoss logs location: `C:\Dev2012\BUILDERS\jboss-eap-8.0\standalone\log\server-info.log`

### stop-jboss.ps1

PowerShell script to stop JBoss EAP 8.0 server:

- Finds and stops the JBoss process safely
- Waits to ensure process is fully stopped

### build-and-deploy.ps1

PowerShell script to build and deploy the arm_am-pom project:

- Uses Java 17 for building
- Uses Maven profile `adv360-DEV`
- Builds the EAR file
- Deploys the EAR file to JBoss deployment directory

### build-and-run-asset-gui.ps1

PowerShell script to build and run the asset-gui project:

- Installs Node.js dependencies (npm install)
- Builds the project with minification (gulp build --minified)
- Starts development server
- Development server will be available at <http://localhost:3000>

## Build and Deploy Workflow

1. Start JBoss server:

```powershell
.\start-jboss.ps1
```

2. Build and deploy the backend:

```powershell
.\build-and-deploy.ps1
```

3. Build and run the frontend:

```powershell
.\build-and-run-asset-gui.ps1
```

- Access JBoss admin console at <http://localhost:9990>
- Access asset-gui frontend at <http://localhost:3000>

## Required Configuration

- JBoss configuration file: `standalone-full-ADV360-BES-EAP_8_POSTGRES.xml` must be present in  
`C:\Dev2012\BUILDERS\jboss-eap-8.0\standalone\configuration\`
- Node.js must be installed to build and run asset-gui
